module WebSocket.Messages
  ( getMessage,
    sendMessage,
  )
where

import ClassyPrelude
import Network.WebSockets qualified as WS
import WebSocket.WSReaderTApp

getMessage ::
  ( HasWSEnv env,
    MonadIO m,
    MonadReader env m
  ) =>
  m Text
getMessage = do
  conn' <- getConn <$> ask
  liftIO $ WS.receiveData conn'

sendMessage ::
  ( HasWSEnv env,
    MonadIO m,
    MonadReader env m
  ) =>
  Text ->
  m ()
sendMessage msg = do
  conn' <- getConn <$> ask
  liftIO $ WS.sendTextData conn' msg
